/* AnimatorScaleInPlace.c generated by valac 0.54.5, the Vala compiler
 * generated from AnimatorScaleInPlace.vala, do not modify */

/*
* Copyright (c) 2021 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Martin Sivak <mars@montik.net>
*/

#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_ANIMATOR_ACTION (animator_action_get_type ())
#define ANIMATOR_ACTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ANIMATOR_ACTION, AnimatorAction))
#define ANIMATOR_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ANIMATOR_ACTION, AnimatorActionClass))
#define IS_ANIMATOR_ACTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ANIMATOR_ACTION))
#define IS_ANIMATOR_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ANIMATOR_ACTION))
#define ANIMATOR_ACTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ANIMATOR_ACTION, AnimatorActionClass))

typedef struct _AnimatorAction AnimatorAction;
typedef struct _AnimatorActionClass AnimatorActionClass;
typedef struct _AnimatorActionPrivate AnimatorActionPrivate;
typedef enum  {
	ANIMATION_TYPE_UNKNOWN = 0,
	ANIMATION_TYPE_NODES,
	ANIMATION_TYPE_NODE,
	ANIMATION_TYPE_PAN,
	ANIMATION_TYPE_SCALE,
	ANIMATION_TYPE_PANSCALE
} AnimationType;

#define TYPE_ANIMATION_TYPE (animation_type_get_type ())

#define TYPE_DRAW_AREA (draw_area_get_type ())
#define DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAW_AREA, DrawArea))
#define DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAW_AREA, DrawAreaClass))
#define IS_DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAW_AREA))
#define IS_DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAW_AREA))
#define DRAW_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAW_AREA, DrawAreaClass))

typedef struct _DrawArea DrawArea;
typedef struct _DrawAreaClass DrawAreaClass;

#define TYPE_ANIMATOR_SCALE_IN_PLACE (animator_scale_in_place_get_type ())
#define ANIMATOR_SCALE_IN_PLACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ANIMATOR_SCALE_IN_PLACE, AnimatorScaleInPlace))
#define ANIMATOR_SCALE_IN_PLACE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ANIMATOR_SCALE_IN_PLACE, AnimatorScaleInPlaceClass))
#define IS_ANIMATOR_SCALE_IN_PLACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ANIMATOR_SCALE_IN_PLACE))
#define IS_ANIMATOR_SCALE_IN_PLACE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ANIMATOR_SCALE_IN_PLACE))
#define ANIMATOR_SCALE_IN_PLACE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ANIMATOR_SCALE_IN_PLACE, AnimatorScaleInPlaceClass))

typedef struct _AnimatorScaleInPlace AnimatorScaleInPlace;
typedef struct _AnimatorScaleInPlaceClass AnimatorScaleInPlaceClass;
typedef struct _AnimatorScaleInPlacePrivate AnimatorScaleInPlacePrivate;
enum  {
	ANIMATOR_SCALE_IN_PLACE_0_PROPERTY,
	ANIMATOR_SCALE_IN_PLACE_NUM_PROPERTIES
};
static GParamSpec* animator_scale_in_place_properties[ANIMATOR_SCALE_IN_PLACE_NUM_PROPERTIES];
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))

struct _AnimatorAction {
	GObject parent_instance;
	AnimatorActionPrivate * priv;
	gchar* _name;
	gint _id;
};

struct _AnimatorActionClass {
	GObjectClass parent_class;
	AnimationType (*type) (AnimatorAction* self);
	void (*capture) (AnimatorAction* self, DrawArea* da);
	void (*adjust) (AnimatorAction* self, DrawArea* da);
};

struct _AnimatorScaleInPlace {
	AnimatorAction parent_instance;
	AnimatorScaleInPlacePrivate * priv;
};

struct _AnimatorScaleInPlaceClass {
	AnimatorActionClass parent_class;
};

struct _AnimatorScaleInPlacePrivate {
	gdouble* _sscale;
	gdouble* _escale;
	gdouble* _ssx;
	gdouble* _ssy;
	gdouble* _dx;
	gdouble* _dy;
};

static gint AnimatorScaleInPlace_private_offset;
static gpointer animator_scale_in_place_parent_class = NULL;

VALA_EXTERN GType animator_action_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AnimatorAction, g_object_unref)
VALA_EXTERN GType animation_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType draw_area_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DrawArea, g_object_unref)
VALA_EXTERN GType animator_scale_in_place_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AnimatorScaleInPlace, g_object_unref)
VALA_EXTERN AnimationType animator_action_type (AnimatorAction* self);
VALA_EXTERN void animator_action_capture (AnimatorAction* self,
                              DrawArea* da);
VALA_EXTERN void animator_action_adjust (AnimatorAction* self,
                             DrawArea* da);
VALA_EXTERN AnimatorScaleInPlace* animator_scale_in_place_new (DrawArea* da,
                                                   const gchar* name,
                                                   gdouble ssx,
                                                   gdouble ssy);
VALA_EXTERN AnimatorScaleInPlace* animator_scale_in_place_construct (GType object_type,
                                                         DrawArea* da,
                                                         const gchar* name,
                                                         gdouble ssx,
                                                         gdouble ssy);
VALA_EXTERN AnimatorAction* animator_action_new (const gchar* name);
VALA_EXTERN AnimatorAction* animator_action_construct (GType object_type,
                                           const gchar* name);
VALA_EXTERN void draw_area_get_origin (DrawArea* self,
                           gdouble* x,
                           gdouble* y);
static gdouble* _double_dup (gdouble* self);
VALA_EXTERN gdouble draw_area_get_sfactor (DrawArea* self);
static AnimationType animator_scale_in_place_real_type (AnimatorAction* base);
static void animator_scale_in_place_real_capture (AnimatorAction* base,
                                           DrawArea* da);
static void animator_scale_in_place_real_adjust (AnimatorAction* base,
                                          DrawArea* da);
VALA_EXTERN gint animator_action_get_index (AnimatorAction* self);
VALA_EXTERN gdouble animator_action_get_frames (AnimatorAction* self);
VALA_EXTERN void animator_action_set_index (AnimatorAction* self,
                                gint value);
VALA_EXTERN void draw_area_set_sfactor (DrawArea* self,
                            gdouble value);
VALA_EXTERN void draw_area_set_origin (DrawArea* self,
                           gdouble x,
                           gdouble y);
static void animator_scale_in_place_finalize (GObject * obj);
static GType animator_scale_in_place_get_type_once (void);

static inline gpointer
animator_scale_in_place_get_instance_private (AnimatorScaleInPlace* self)
{
	return G_STRUCT_MEMBER_P (self, AnimatorScaleInPlace_private_offset);
}

static gdouble*
_double_dup (gdouble* self)
{
	gdouble* dup;
	dup = g_new0 (gdouble, 1);
	memcpy (dup, self, sizeof (gdouble));
	return dup;
}

static gpointer
__double_dup0 (gpointer self)
{
	return self ? _double_dup (self) : NULL;
}

AnimatorScaleInPlace*
animator_scale_in_place_construct (GType object_type,
                                   DrawArea* da,
                                   const gchar* name,
                                   gdouble ssx,
                                   gdouble ssy)
{
	AnimatorScaleInPlace * self = NULL;
	gdouble* _sox = NULL;
	gdouble* _soy = NULL;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_;
	gdouble* _tmp3_;
	gdouble _tmp4_;
	gdouble* _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble* _tmp8_;
	gdouble* _tmp9_;
	gdouble* _tmp10_;
	gdouble* _tmp11_;
	gdouble* _tmp12_;
	gdouble* _tmp13_;
	gdouble _tmp14_;
	gdouble* _tmp15_;
	gdouble* _tmp16_;
	gdouble* _tmp17_;
	gdouble* _tmp18_;
	gdouble _tmp19_;
	gdouble* _tmp20_;
	g_return_val_if_fail (da != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	self = (AnimatorScaleInPlace*) animator_action_construct (object_type, name);
	_sox = NULL;
	_soy = NULL;
	draw_area_get_origin (da, &_tmp0_, &_tmp1_);
	_g_free0 (_sox);
	_tmp2_ = _tmp0_;
	_tmp3_ = __double_dup0 (&_tmp2_);
	_sox = _tmp3_;
	_g_free0 (_soy);
	_tmp4_ = _tmp1_;
	_tmp5_ = __double_dup0 (&_tmp4_);
	_soy = _tmp5_;
	_tmp6_ = draw_area_get_sfactor (da);
	_tmp7_ = _tmp6_;
	_tmp8_ = __double_dup0 (&_tmp7_);
	_g_free0 (self->priv->_sscale);
	self->priv->_sscale = _tmp8_;
	_tmp9_ = __double_dup0 (&ssx);
	_g_free0 (self->priv->_ssx);
	self->priv->_ssx = _tmp9_;
	_tmp10_ = __double_dup0 (&ssy);
	_g_free0 (self->priv->_ssy);
	self->priv->_ssy = _tmp10_;
	_tmp11_ = _sox;
	_tmp12_ = self->priv->_ssx;
	_tmp13_ = self->priv->_sscale;
	_tmp14_ = (*_tmp11_) + ((*_tmp12_) / (*_tmp13_));
	_tmp15_ = __double_dup0 (&_tmp14_);
	_g_free0 (self->priv->_dx);
	self->priv->_dx = _tmp15_;
	_tmp16_ = _soy;
	_tmp17_ = self->priv->_ssy;
	_tmp18_ = self->priv->_sscale;
	_tmp19_ = (*_tmp16_) + ((*_tmp17_) / (*_tmp18_));
	_tmp20_ = __double_dup0 (&_tmp19_);
	_g_free0 (self->priv->_dy);
	self->priv->_dy = _tmp20_;
	_g_free0 (_soy);
	_g_free0 (_sox);
	return self;
}

AnimatorScaleInPlace*
animator_scale_in_place_new (DrawArea* da,
                             const gchar* name,
                             gdouble ssx,
                             gdouble ssy)
{
	return animator_scale_in_place_construct (TYPE_ANIMATOR_SCALE_IN_PLACE, da, name, ssx, ssy);
}

static AnimationType
animator_scale_in_place_real_type (AnimatorAction* base)
{
	AnimatorScaleInPlace * self;
	AnimationType result = 0;
	self = (AnimatorScaleInPlace*) base;
	result = ANIMATION_TYPE_PANSCALE;
	return result;
}

static void
animator_scale_in_place_real_capture (AnimatorAction* base,
                                      DrawArea* da)
{
	AnimatorScaleInPlace * self;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble* _tmp2_;
	self = (AnimatorScaleInPlace*) base;
	g_return_if_fail (da != NULL);
	_tmp0_ = draw_area_get_sfactor (da);
	_tmp1_ = _tmp0_;
	_tmp2_ = __double_dup0 (&_tmp1_);
	_g_free0 (self->priv->_escale);
	self->priv->_escale = _tmp2_;
}

static void
animator_scale_in_place_real_adjust (AnimatorAction* base,
                                     DrawArea* da)
{
	AnimatorScaleInPlace * self;
	gdouble divisor = 0.0;
	gint _tmp0_;
	gint _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gdouble sf = 0.0;
	gdouble* _tmp6_;
	gdouble* _tmp7_;
	gdouble* _tmp8_;
	gdouble newo_x = 0.0;
	gdouble* _tmp9_;
	gdouble* _tmp10_;
	gdouble newo_y = 0.0;
	gdouble* _tmp11_;
	gdouble* _tmp12_;
	self = (AnimatorScaleInPlace*) base;
	g_return_if_fail (da != NULL);
	_tmp0_ = animator_action_get_index ((AnimatorAction*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = animator_action_get_frames ((AnimatorAction*) self);
	_tmp3_ = _tmp2_;
	divisor = _tmp1_ / _tmp3_;
	_tmp4_ = animator_action_get_index ((AnimatorAction*) self);
	_tmp5_ = _tmp4_;
	animator_action_set_index ((AnimatorAction*) self, _tmp5_ + 1);
	_tmp6_ = self->priv->_sscale;
	_tmp7_ = self->priv->_escale;
	_tmp8_ = self->priv->_sscale;
	sf = (*_tmp6_) + (((*_tmp7_) - (*_tmp8_)) * divisor);
	draw_area_set_sfactor (da, sf);
	_tmp9_ = self->priv->_dx;
	_tmp10_ = self->priv->_ssx;
	newo_x = (*_tmp9_) - ((*_tmp10_) / sf);
	_tmp11_ = self->priv->_dy;
	_tmp12_ = self->priv->_ssy;
	newo_y = (*_tmp11_) - ((*_tmp12_) / sf);
	draw_area_set_origin (da, newo_x, newo_y);
}

static void
animator_scale_in_place_class_init (AnimatorScaleInPlaceClass * klass,
                                    gpointer klass_data)
{
	animator_scale_in_place_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &AnimatorScaleInPlace_private_offset);
	((AnimatorActionClass *) klass)->type = (AnimationType (*) (AnimatorAction*)) animator_scale_in_place_real_type;
	((AnimatorActionClass *) klass)->capture = (void (*) (AnimatorAction*, DrawArea*)) animator_scale_in_place_real_capture;
	((AnimatorActionClass *) klass)->adjust = (void (*) (AnimatorAction*, DrawArea*)) animator_scale_in_place_real_adjust;
	G_OBJECT_CLASS (klass)->finalize = animator_scale_in_place_finalize;
}

static void
animator_scale_in_place_instance_init (AnimatorScaleInPlace * self,
                                       gpointer klass)
{
	self->priv = animator_scale_in_place_get_instance_private (self);
	self->priv->_sscale = NULL;
	self->priv->_escale = NULL;
	self->priv->_ssx = NULL;
	self->priv->_ssy = NULL;
	self->priv->_dx = NULL;
	self->priv->_dy = NULL;
}

static void
animator_scale_in_place_finalize (GObject * obj)
{
	AnimatorScaleInPlace * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ANIMATOR_SCALE_IN_PLACE, AnimatorScaleInPlace);
	_g_free0 (self->priv->_sscale);
	_g_free0 (self->priv->_escale);
	_g_free0 (self->priv->_ssx);
	_g_free0 (self->priv->_ssy);
	_g_free0 (self->priv->_dx);
	_g_free0 (self->priv->_dy);
	G_OBJECT_CLASS (animator_scale_in_place_parent_class)->finalize (obj);
}

static GType
animator_scale_in_place_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AnimatorScaleInPlaceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) animator_scale_in_place_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AnimatorScaleInPlace), 0, (GInstanceInitFunc) animator_scale_in_place_instance_init, NULL };
	GType animator_scale_in_place_type_id;
	animator_scale_in_place_type_id = g_type_register_static (TYPE_ANIMATOR_ACTION, "AnimatorScaleInPlace", &g_define_type_info, 0);
	AnimatorScaleInPlace_private_offset = g_type_add_instance_private (animator_scale_in_place_type_id, sizeof (AnimatorScaleInPlacePrivate));
	return animator_scale_in_place_type_id;
}

GType
animator_scale_in_place_get_type (void)
{
	static volatile gsize animator_scale_in_place_type_id__volatile = 0;
	if (g_once_init_enter (&animator_scale_in_place_type_id__volatile)) {
		GType animator_scale_in_place_type_id;
		animator_scale_in_place_type_id = animator_scale_in_place_get_type_once ();
		g_once_init_leave (&animator_scale_in_place_type_id__volatile, animator_scale_in_place_type_id);
	}
	return animator_scale_in_place_type_id__volatile;
}

